/**
 * Copyright 1998-2007, CHISEL Group, University of Victoria, Victoria, BC, Canada.
 * All rights reserved.
 */
package ca.uvic.csr.shrimp.usercontrols;

import ca.uvic.csr.shrimp.SelectorBeanConstants;
import ca.uvic.csr.shrimp.DisplayBean.DisplayBean;
import ca.uvic.csr.shrimp.DisplayBean.ShrimpNode;
import ca.uvic.csr.shrimp.SelectorBean.SelectorBean;
import ca.uvic.csr.shrimp.ShrimpApplication.BeanNotFoundException;
import ca.uvic.csr.shrimp.ShrimpTool.ShrimpTool;


/**
 * Base class for Fisheye In and Out actions.
 * 
 * @see FisheyeInAdapter
 * @see FisheyeOutAdapter
 * @author Chris Callendar
 * @date June 25th, 2006
 */
public abstract class FisheyeAdapter extends ZoomAction {
	
	public FisheyeAdapter(String actionName, ShrimpTool tool, String direction, String tooltip) {
		super(actionName, tool, direction, tooltip);
	}

    public boolean canStart() {
    	boolean canStart = false;
	    try {
			SelectorBean selectorBean =  (SelectorBean) tool.getBean(ShrimpTool.SELECTOR_BEAN);
			Object targetObject = selectorBean.getSelected(SelectorBeanConstants.TARGET_OBJECT);
			canStart = (targetObject instanceof ShrimpNode);
		} catch (BeanNotFoundException bnfe) {
		}
		return canStart;
    }
    
	/**
	 * Stops fisheyeing
	 */
	public void stopAction() {
		try {
			DisplayBean displayBean = (DisplayBean) tool.getBean(ShrimpTool.DISPLAY_BEAN);		
			displayBean.stopFisheyeing();
		} catch (BeanNotFoundException bnfe) {
			bnfe.printStackTrace();
		}		
	}	

}
