package uk.ac.ebi.interpro.graphdraw;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

/**
 * Graph, contains the nodes, edges and utility methods
 */
public class StandardGraph implements Graph {

    public List nodes=new ArrayList();
    public List edges=new ArrayList();

    public Collection getNodes() {
        return nodes;
    }
    public Collection getEdges() {
        return edges;
    }

    public Set parents(Node a) {
        Set results = new HashSet();
        for (Iterator i = edges.iterator(); i.hasNext();) {
            Edge e = (Edge) i.next();
            if (e.getChild() == a) results.add(e.getParent());
        }
        return results;
    }

    public Set children(Node a) {
        Set results = new HashSet();
        for (Iterator i = edges.iterator(); i.hasNext();) {
            Edge e = (Edge) i.next();
            if (e.getParent() == a) results.add(e.getChild());
        }
        return results;
    }

    public Edge findEdge(Node p, Node c) {
        for (Iterator i = edges.iterator(); i.hasNext();) {
            final Object o = i.next();

            Edge e = (Edge) o;
            if ((e.getParent() == p) && (e.getChild() == c)) return e;
        }
        return null;
    }

    public boolean connected(Node a, Node b) {
        return (findEdge(a, b) != null) || (findEdge(b, a) != null);
    }

}
